package com.nisum.mytime.service;

import java.util.HashMap;
import java.util.List;
import java.util.Set;
import org.springframework.stereotype.Service;
import com.nisum.mytime.exception.handler.MyTimeException;
import com.nisum.mytime.model.Account;
import com.nisum.mytime.model.Employee;

@Service
public interface IEmployeeService {

	boolean isEmployeeExistsById(String employeeId);

	Employee createEmployee(Employee employeeRoles, String empId) throws MyTimeException;

	Employee updateEmployee(Employee employeeRoles, String empId);

	Employee deleteEmployee(String empId);

	Employee updateProfile(Employee employeeRoles) throws MyTimeException;

	Employee getEmployeeById(String empId);

	Employee getEmployeeByEmaillId(String emailId);

	List<Employee> getManagers() throws MyTimeException;

	List<Employee> getActiveEmployees() throws MyTimeException;

	List<Employee> getEmployeesByStatus(String status);

	List<Account> getAccounts() throws MyTimeException;

	Employee getEmployeeRoleDataForSearchCriteria(String searchId, String searchAttribute);

	List<String> getEmployeeDetailsForAutocomplete();

	List<HashMap<String, String>> getDeliveryLeads(String domainId);

	List<Employee> getEmployeesByFunctionalGrp(String functionalGrp);

	boolean verifyEmployeeRole(String empId, String roleName);

	List<Employee> getEmployeesFromList(Set<String> empIdsSet);

}
