package com.nisum.mytime.service;

import java.util.HashMap;
import java.util.List;
import java.util.Set;

import org.bson.types.ObjectId;

import com.nisum.mytime.exception.handler.MyTimeException;
import com.nisum.mytime.model.Billing;
import com.nisum.mytime.model.EmpLoginData;
import com.nisum.mytime.model.EmployeeDashboardVO;
import com.nisum.mytime.model.Employee;
import com.nisum.mytime.model.Project;
import com.nisum.mytime.model.Resource;

public interface IProjectService {

	
	public Resource addNewBeanchAllocation(Employee employee,String loginEmpId);
	
    List<EmpLoginData> employeeLoginsBasedOnDate(long id, String fromDate,
            String toDate) throws MyTimeException;

    List<HashMap<Object, Object>> getProjects() throws MyTimeException;

    Project addProject(Project project, String loginEmpId) throws MyTimeException;

    String generatePdfReport(long id, String fromDate, String toDate)
            throws MyTimeException;

    Employee getEmployeesRole(String emailId);

    void deleteProject(String projectId);

    Project updateProject(Project project, String loginEmpId)throws MyTimeException;

    Employee getEmployeesRoleData(String empId);

    List<Resource> getTeamDetails(String empId);
    
    //MT-72
    List<Resource> getProjectInfo(String empId);

    public Resource addProjectTeamMate(Resource projectTeamMate, String loginEmpId)
            throws MyTimeException;

    String updateTeammate(Resource projectTeamMate, String loginEmpId) throws MyTimeException;

    void deleteTeammate(String empId, String projectId, ObjectId id, String loginEmpId);

    List<Project> getProjects(String managerId) throws MyTimeException;

    List<Resource> getMyTeamDetails(String empId);

    List<Employee> getUnAssignedEmployees();

    List<Resource> getShiftDetails(String shift);

    List<Resource> getAllProjectDetails();

    List<Resource> getProjectDetails(String projectId,String status);

    public List<Resource> getMyProjectAllocations(String empId);

    List<Billing> getEmployeeBillingDetails(String empId,
            String projectId);

    Billing addEmployeeBillingDetails(Billing billingDetails, String loginEmpId);

    Billing updateEmployeeBilling(Billing billingDetails, String loginEmpId);

    void deleteEmployeeBilling(Billing teamMate);

    public List<EmployeeDashboardVO> getEmployeesDashBoard();

    List<Billing> getEmployeeActiveBillingDetails(String empId,
            String projectId);

    List<Billing> getEmployeeActiveNisumBench(String empId);

    List<Billing> getEmployeeBillingDetailsAll(String empId);

    public void updateShiftDetails(Resource existingTeammate, String loginEmpId);

    public void addShiftDetails(Resource projectTeamMate, String loginEmpId);

    List<Resource> findByAccountAndActiveAndBillableStatus(
            String account, boolean status, String billableStatus);
    
    public String addProjectTeamMateWithCheck(Resource projectTeamMate, String loginEmpId)
            throws MyTimeException;

    public List<HashMap<Object, Object>>  projectsInfoByEmpId(String empId);
    
    public Set<String> accountsAssignedToDl(String empId);
    
    public List<HashMap<Object, Object>> deliveryLeadProjects(String empId) throws MyTimeException;
}
