package com.nisum.mytime.service.impl;

import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;
import com.nisum.mytime.model.Billing;
import com.nisum.mytime.model.Employee;
import com.nisum.mytime.repository.BillingRepo;
import com.nisum.mytime.service.IBillingService;
import com.nisum.mytime.utils.MyTimeUtils;

import lombok.extern.slf4j.Slf4j;


@Service
@Slf4j
public class BillingService implements IBillingService {

	@Autowired
	private BillingRepo billingRepo;

	@Autowired
	private MongoTemplate mongoTemplate;

	@Override
	public List<Billing> getEmployeeActiveBillingDetails(String empId, String projectId) {
		Query query4 = new Query();
		query4.addCriteria(Criteria.where("active").is(new Boolean(true)));
		query4.addCriteria(Criteria.where("employeeId").is(empId));
		query4.addCriteria(Criteria.where("projectId").is(projectId));
		List<Billing> billings = mongoTemplate.find(query4, Billing.class);
		List<Billing> billingsSorted = billings;
		try {
			billingsSorted = (billings == null || billings.size() == 0) ? billings
					: billings.stream().sorted(Comparator.comparing(Billing::getBillingStartDate).reversed())
							.collect(Collectors.toList());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return billingsSorted;
	}

	public Billing addBillingtoResource(Billing billing, Employee employee, String loginEmpId) {

		billing.setBillingEndDate(employee.getEndDate());
		billing.setActive(false);
		billing.setAuditFields(loginEmpId, MyTimeUtils.UPDATE);
		return billingRepo.save(billing);

	}

}
