package com.nisum.mytime.service.impl;

import java.util.Calendar;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.data.mongodb.core.query.Query;
import org.springframework.stereotype.Service;

import com.nisum.mytime.model.EmpShiftDetails;
import com.nisum.mytime.model.Resource;
import com.nisum.mytime.service.IEmployeeShiftService;
import com.nisum.mytime.utils.MyTimeUtils;

import lombok.extern.slf4j.Slf4j;

@Service
@Slf4j
public class EmployeeShiftService implements IEmployeeShiftService{

	@Autowired
	private MongoTemplate mongoTemplate;
	
	public void updateShiftDetails(Resource existingTeammate, String loginEmpId) {
		Query getQuery = new Query();
		getQuery.addCriteria(new Criteria().andOperator(Criteria.where("active").is(true),
				Criteria.where("employeeId").is(existingTeammate.getEmployeeId())));
		Calendar cal = Calendar.getInstance();
		cal.add(Calendar.DATE, -1);
		EmpShiftDetails existingShift = mongoTemplate.findOne(getQuery, EmpShiftDetails.class);
		if (existingShift != null) {
			existingShift.setActive(false);
			// existingShift.setUpdatedDate(new Date());// Commented as added
			// common audit fields
			existingShift.setAuditFields(loginEmpId, MyTimeUtils.UPDATE);
			mongoTemplate.save(existingShift);
		}
	}
	
	
}
