package com.nisum.mytime.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.nisum.mytime.exception.handler.MyTimeException;
import com.nisum.mytime.model.Role;
import com.nisum.mytime.repository.RoleRepo;
import com.nisum.mytime.service.IRoleService;

import lombok.extern.slf4j.Slf4j;

@Service
@Slf4j
public class RoleService implements IRoleService {

	@Autowired
	RoleRepo roleRepo;

	@Override
	public Role addRole(Role roleInfo) throws MyTimeException {

		return roleRepo.save(roleInfo);
	}

	@Override
	public String getRole(String roleName) throws MyTimeException {

		return roleRepo.findByRoleName(roleName).getRoleId();
	}

}
